using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories;
using Bp.Sync.Domain.Elastics.Inventories.Bills;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IRetailBillRepository
    {
        Task<BaseResult> Add(RetailBillElastic RetailBill);
        Task<BaseResult> AddManyAsync(IEnumerable<RetailBillElastic> RetailBills);
        Task<SmartTableResult<RetailBillElastic>> Search(BoolQueryDescriptor<RetailBillElastic> query);

    }
    public class RetailBillRepository : IRetailBillRepository
    {
        private readonly ElasticIndex<RetailBillElastic> _dbContext;

        public RetailBillRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<RetailBillElastic>(settings.Value.ClusterUrl, "inventoryretailbill");
        }


        public async Task<SmartTableResult<RetailBillElastic>> Search(BoolQueryDescriptor<RetailBillElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(RetailBillElastic RetailBill)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(RetailBill);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<RetailBillElastic> RetailBills)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(RetailBills);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

    }
}
